#include "stdafx.h"
#include <windowsx.h>
#include "resource.h"

extern HINSTANCE hInstance;


BOOL CALLBACK DialogProc(
  HWND hDlg,  // handle to dialog box
  UINT uMsg,     // message
  WPARAM wParam, // first message parameter
  LPARAM lParam  // second message parameter
)
{
	switch( uMsg )
	{
	    case WM_INITDIALOG:
			return FALSE;

		case WM_COMMAND:
			{
				switch(LOWORD(wParam))
				{
					case IDOK:
						EndDialog( hDlg, TRUE );
						break;
					default:
						return FALSE;
				}
			}
		default:
			return FALSE;
	}
	return TRUE;
}

LRESULT OnCommand( HWND hWnd, WPARAM wParam, LPARAM lParam )
{
	switch (GET_WM_COMMAND_ID(wParam, lParam))
	{
		case IDM_ABOUT:
			DialogBox( hInstance, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, (DLGPROC)DialogProc );
			break;
		case IDM_QUIT:
			PostMessage(hWnd, WM_CLOSE, 0, 0L);
			break;
		default:
			return DefWindowProc(hWnd, WM_COMMAND, wParam, lParam);
    }
    return 0;
}
