#include "stdafx.h"
#include <strsafe.h>
#include <Shlwapi.h>
#include <Wtsapi32.h>

BOOL runInUserSession(TCHAR* progPath, DWORD sessionID )
 {

		HANDLE              hToken;
//        HDESK               hdesk;
//        PSID                psid;
//        HWINSTA             hwinsta;
        PROCESS_INFORMATION pi;
        STARTUPINFO         si;
		HANDLE				hTokenDup;

		if( sessionID == 0 )
             return FALSE;

		if( sessionID == 0xffffffff )
             return FALSE;


		WTSQueryUserToken( sessionID, &hToken );

		DuplicateTokenEx(hToken,MAXIMUM_ALLOWED,NULL,SecurityIdentification,TokenPrimary, &hTokenDup) ;

        // 
        // 
        // initialize STARTUPINFO structure
        // 
        ZeroMemory(&si, sizeof(STARTUPINFO));
        si.cb        = sizeof(STARTUPINFO);
        si.lpDesktop = L"winsta0\\default";

		WCHAR szCmdParam[MAX_PATH];

		StringCchPrintfW( szCmdParam, MAX_PATH, L"%s", progPath );

        // 
        // start the process
        // 
        if (!CreateProcessAsUser(
             hTokenDup,
             NULL,
             szCmdParam,
             NULL,
             NULL,
             FALSE,
             NORMAL_PRIORITY_CLASS,
             NULL,
             NULL,
             &si,
             &pi
             ))
		{
             return FALSE;
		}

        // 
        // close the handles
        // 

		CloseHandle(hTokenDup);

        CloseHandle(pi.hProcess);

        CloseHandle(pi.hThread);

        return TRUE;
   }

void showMsgInUserSession( TCHAR* title, TCHAR* msg )
{
	DWORD r;

	WTSSendMessage(WTS_CURRENT_SERVER_HANDLE , WTSGetActiveConsoleSessionId(), 
			title, (DWORD)wcslen(title)*sizeof(TCHAR),
			msg,   (DWORD)wcslen(msg)*sizeof(TCHAR), 
			MB_OK, 10,  &r, TRUE );

}